/*
  KindkePageTurner

    written by NovemberKou
    Licence: CC BY-NC-SA 4.0 (Attribution-NonCommercial-ShareAlike 4.0 International)
    Version 1.0

  This software uses "Rotary Encoder Arduino Library" by brianlow.
    https://github.com/brianlow/Rotary
*/
#include <Keyboard.h>
#include <Rotary.h> // It is recommended to enable "HALF_STEP" in "Rotary.h".

// Arduino pin number
constexpr char ROTARY_PHASE_A_PIN = 9;
constexpr char ROTARY_PHASE_B_PIN = 8;

// hot key
constexpr char CLOCKWISE_HOTKEY         = KEY_PAGE_UP;
constexpr char COUNTER_CLOCKWISE_HOTKEY = KEY_PAGE_DOWN;

// other settings
constexpr unsigned long KEY_PRESS_TIME_msec = 100;

Rotary page_turn_rotary = Rotary(ROTARY_PHASE_A_PIN, ROTARY_PHASE_B_PIN);

void setup()
{
  Keyboard.begin();
  page_turn_rotary.begin(true);
}

void loop()
{
  unsigned char rotary_changed = page_turn_rotary.process();
  if(rotary_changed)
  {
    Keyboard.press(rotary_changed == DIR_CCW ? COUNTER_CLOCKWISE_HOTKEY : CLOCKWISE_HOTKEY);
    delay(KEY_PRESS_TIME_msec);
    Keyboard.releaseAll();
  }
}
